Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/HiveJanitor.cs	(revision 12858)
@@ -55,20 +55,21 @@
 
     public void RunCleanup() {
+      var pm = PersistenceManager;
       while (!stop) {
         try {
           LogFactory.GetLogger(typeof(HiveJanitor).Namespace).Log("HiveJanitor: starting cleanup.");
           bool cleanup = false;
-          using (var pm = PersistenceManager) {
-            var lifecycleDao = pm.LifecycleDao;
-            pm.UseTransaction(() => {
-              var lifecycle = lifecycleDao.GetLastLifecycle();
-              if (lifecycle == null
-                  || DateTime.Now - lifecycle.LastCleanup > HeuristicLab.Services.Hive.Properties.Settings.Default.CleanupInterval) {
-                lifecycleDao.UpdateLifecycle();
-                cleanup = true;
-              }
-              pm.SubmitChanges();
-            }, true);
-          }
+
+          var lifecycleDao = pm.LifecycleDao;
+          pm.UseTransaction(() => {
+            var lifecycle = lifecycleDao.GetLastLifecycle();
+            if (lifecycle == null
+                || DateTime.Now - lifecycle.LastCleanup > HeuristicLab.Services.Hive.Properties.Settings.Default.CleanupInterval) {
+              lifecycleDao.UpdateLifecycle();
+              cleanup = true;
+            }
+            pm.SubmitChanges();
+          }, true);
+
           if (cleanup) {
             EventManager.Cleanup();
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/AuthorizationManager.cs	(revision 12858)
@@ -52,34 +52,31 @@
     public void AuthorizeForTask(Guid taskId, DT.Permission requiredPermission) {
       if (ServiceLocator.Instance.RoleVerifier.IsInRole(HiveRoles.Slave)) return; // slave-users can access all tasks
-      using (var pm = PersistenceManager) {
-        var taskDao = pm.TaskDao;
-        pm.UseTransaction(() => {
-          var task = taskDao.GetById(taskId);
-          if (task == null) throw new SecurityException(NOT_AUTHORIZED);
-          AuthorizeJob(pm, task.JobId, requiredPermission);
-        });
-      }
+      var pm = PersistenceManager;
+      var taskDao = pm.TaskDao;
+      pm.UseTransaction(() => {
+        var task = taskDao.GetById(taskId);
+        if (task == null) throw new SecurityException(NOT_AUTHORIZED);
+        AuthorizeJob(pm, task.JobId, requiredPermission);
+      });
     }
 
     public void AuthorizeForJob(Guid jobId, DT.Permission requiredPermission) {
-      using (var pm = PersistenceManager) {
-        pm.UseTransaction(() => {
-          AuthorizeJob(pm, jobId, requiredPermission);
-        });
-      }
+      var pm = PersistenceManager;
+      pm.UseTransaction(() => {
+        AuthorizeJob(pm, jobId, requiredPermission);
+      });
     }
 
     public void AuthorizeForResourceAdministration(Guid resourceId) {
-      using (var pm = PersistenceManager) {
-        var resourceDao = pm.ResourceDao;
-        pm.UseTransaction(() => {
-          var resource = resourceDao.GetById(resourceId);
-          if (resource == null) throw new SecurityException(NOT_AUTHORIZED);
-          if (resource.OwnerUserId != UserManager.CurrentUserId
-              && !RoleVerifier.IsInRole(HiveRoles.Administrator)) {
-            throw new SecurityException(NOT_AUTHORIZED);
-          }
-        });
-      }
+      var pm = PersistenceManager;
+      var resourceDao = pm.ResourceDao;
+      pm.UseTransaction(() => {
+        var resource = resourceDao.GetById(resourceId);
+        if (resource == null) throw new SecurityException(NOT_AUTHORIZED);
+        if (resource.OwnerUserId != UserManager.CurrentUserId
+            && !RoleVerifier.IsInRole(HiveRoles.Administrator)) {
+          throw new SecurityException(NOT_AUTHORIZED);
+        }
+      });
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewEventManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewEventManager.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewEventManager.cs	(revision 12858)
@@ -31,26 +31,19 @@
       get { return ServiceLocator.Instance.PersistenceManager; }
     }
-    private IAuthorizationManager AuthorizationManager {
-      get { return ServiceLocator.Instance.AuthorizationManager; }
-    }
-    private ILogger Log {
-      get { return LogFactory.GetLogger(this.GetType().Namespace); }
-    }
 
     public void Cleanup() {
-      using (var pm = PersistenceManager) {
-        // same transactions as the old EventManager
-        pm.UseTransaction(() => {
-          SetTimeoutSlavesOffline(pm);
-          SetTimeoutTasksWaiting(pm);
-          DeleteObsoleteSlaves(pm);
-          pm.SubmitChanges();
-        });
+      var pm = PersistenceManager;
+      // same transactions as the old EventManager
+      pm.UseTransaction(() => {
+        SetTimeoutSlavesOffline(pm);
+        SetTimeoutTasksWaiting(pm);
+        DeleteObsoleteSlaves(pm);
+        pm.SubmitChanges();
+      });
 
-        pm.UseTransaction(() => {
-          FinishParentTasks(pm);
-          pm.SubmitChanges();
-        });
-      }
+      pm.UseTransaction(() => {
+        FinishParentTasks(pm);
+        pm.SubmitChanges();
+      });
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewHeartbeatManager.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewHeartbeatManager.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Manager/NewHeartbeatManager.cs	(revision 12858)
@@ -47,67 +47,66 @@
     public List<MessageContainer> ProcessHeartbeat(Heartbeat heartbeat) {
       List<MessageContainer> actions = new List<MessageContainer>();
-      using (var pm = PersistenceManager) {
-        var slaveDao = pm.SlaveDao;
-        var taskDao = pm.TaskDao;
-        var slave = pm.UseTransaction(() => slaveDao.GetById(heartbeat.SlaveId));
-        if (slave == null) {
-          actions.Add(new MessageContainer(MessageContainer.MessageType.SayHello));
-        } else {
-          if (heartbeat.HbInterval != slave.HbInterval) {
-            actions.Add(new MessageContainer(MessageContainer.MessageType.NewHBInterval));
-          }
-          if (slaveDao.SlaveHasToShutdownComputer(slave.ResourceId)) {
-            actions.Add(new MessageContainer(MessageContainer.MessageType.ShutdownComputer));
-          }
-          // update slave data  
-          slave.FreeCores = heartbeat.FreeCores;
-          slave.FreeMemory = heartbeat.FreeMemory;
-          slave.CpuUtilization = heartbeat.CpuUtilization;
-          slave.SlaveState = (heartbeat.JobProgress != null && heartbeat.JobProgress.Count > 0)
-            ? DA.SlaveState.Calculating
-            : DA.SlaveState.Idle;
-          slave.LastHeartbeat = DateTime.Now;
-          pm.UseTransaction(() => {
-            slave.IsAllowedToCalculate = slaveDao.SlaveIsAllowedToCalculate(slave.ResourceId);
-            pm.SubmitChanges();
-          });
-
-          // update task data
-          actions.AddRange(UpdateTasks(pm, heartbeat, slave.IsAllowedToCalculate));
-
-          // assign new task
-          if (heartbeat.AssignJob && slave.IsAllowedToCalculate && heartbeat.FreeCores > 0) {
-            bool mutexAquired = false;
-            var mutex = new Mutex(false, MutexName);
-            try {
-              mutexAquired = mutex.WaitOne(Properties.Settings.Default.SchedulingPatience);
-              if (mutexAquired) {
-                var waitingTasks = pm.UseTransaction(() => taskDao.GetWaitingTasks(slave)
-                    .Select(x => new TaskInfoForScheduler {
-                      TaskId = x.TaskId,
-                      JobId = x.JobId,
-                      Priority = x.Priority
-                    })
-                    .ToList()
-                );
-                var availableTasks = TaskScheduler.Schedule(waitingTasks);
-                if (availableTasks.Any()) {
-                  var task = availableTasks.First();
-                  AssignTask(pm, slave, task.TaskId);
-                  actions.Add(new MessageContainer(MessageContainer.MessageType.CalculateTask, task.TaskId));
-                }
-              } else {
-                LogFactory.GetLogger(this.GetType().Namespace).Log("HeartbeatManager: The mutex used for scheduling could not be aquired.");
+      var pm = PersistenceManager;
+      var slaveDao = pm.SlaveDao;
+      var taskDao = pm.TaskDao;
+      var slave = pm.UseTransaction(() => slaveDao.GetById(heartbeat.SlaveId));
+      if (slave == null) {
+        actions.Add(new MessageContainer(MessageContainer.MessageType.SayHello));
+      } else {
+        if (heartbeat.HbInterval != slave.HbInterval) {
+          actions.Add(new MessageContainer(MessageContainer.MessageType.NewHBInterval));
+        }
+        if (slaveDao.SlaveHasToShutdownComputer(slave.ResourceId)) {
+          actions.Add(new MessageContainer(MessageContainer.MessageType.ShutdownComputer));
+        }
+        // update slave data  
+        slave.FreeCores = heartbeat.FreeCores;
+        slave.FreeMemory = heartbeat.FreeMemory;
+        slave.CpuUtilization = heartbeat.CpuUtilization;
+        slave.SlaveState = (heartbeat.JobProgress != null && heartbeat.JobProgress.Count > 0)
+          ? DA.SlaveState.Calculating
+          : DA.SlaveState.Idle;
+        slave.LastHeartbeat = DateTime.Now;
+        pm.UseTransaction(() => {
+          slave.IsAllowedToCalculate = slaveDao.SlaveIsAllowedToCalculate(slave.ResourceId);
+          pm.SubmitChanges();
+        });
+
+        // update task data
+        actions.AddRange(UpdateTasks(pm, heartbeat, slave.IsAllowedToCalculate));
+
+        // assign new task
+        if (heartbeat.AssignJob && slave.IsAllowedToCalculate && heartbeat.FreeCores > 0) {
+          bool mutexAquired = false;
+          var mutex = new Mutex(false, MutexName);
+          try {
+            mutexAquired = mutex.WaitOne(Properties.Settings.Default.SchedulingPatience);
+            if (mutexAquired) {
+              var waitingTasks = pm.UseTransaction(() => taskDao.GetWaitingTasks(slave)
+                  .Select(x => new TaskInfoForScheduler {
+                    TaskId = x.TaskId,
+                    JobId = x.JobId,
+                    Priority = x.Priority
+                  })
+                  .ToList()
+              );
+              var availableTasks = TaskScheduler.Schedule(waitingTasks).ToArray();
+              if (availableTasks.Any()) {
+                var task = availableTasks.First();
+                AssignTask(pm, slave, task.TaskId);
+                actions.Add(new MessageContainer(MessageContainer.MessageType.CalculateTask, task.TaskId));
               }
+            } else {
+              LogFactory.GetLogger(this.GetType().Namespace).Log("HeartbeatManager: The mutex used for scheduling could not be aquired.");
             }
-            catch (AbandonedMutexException) {
-              LogFactory.GetLogger(this.GetType().Namespace).Log("HeartbeatManager: The mutex used for scheduling has been abandoned.");
-            }
-            catch (Exception ex) {
-              LogFactory.GetLogger(this.GetType().Namespace).Log(string.Format("HeartbeatManager threw an exception in ProcessHeartbeat: {0}", ex));
-            }
-            finally {
-              if (mutexAquired) mutex.ReleaseMutex();
-            }
+          }
+          catch (AbandonedMutexException) {
+            LogFactory.GetLogger(this.GetType().Namespace).Log("HeartbeatManager: The mutex used for scheduling has been abandoned.");
+          }
+          catch (Exception ex) {
+            LogFactory.GetLogger(this.GetType().Namespace).Log(string.Format("HeartbeatManager threw an exception in ProcessHeartbeat: {0}", ex));
+          }
+          finally {
+            if (mutexAquired) mutex.ReleaseMutex();
           }
         }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Scheduler/NewRoundRobinTaskScheduler.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Scheduler/NewRoundRobinTaskScheduler.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.Hive/3.3/Scheduler/NewRoundRobinTaskScheduler.cs	(revision 12858)
@@ -35,63 +35,63 @@
       if (!tasks.Any()) return Enumerable.Empty<TaskInfoForScheduler>();
 
-      using (var pm = PersistenceManager) {
-        var userPriorityDao = pm.UserPriorityDao;
-        var jobDao = pm.JobDao;
+      var pm = PersistenceManager;
+      var userPriorityDao = pm.UserPriorityDao;
+      var jobDao = pm.JobDao;
 
-        var userPriorities = pm.UseTransaction(() => userPriorityDao.GetAll()
-          .OrderBy(x => x.DateEnqueued)
-          .ToArray()
-        );
+      var userPriorities = pm.UseTransaction(() => userPriorityDao.GetAll()
+        .OrderBy(x => x.DateEnqueued)
+        .ToArray()
+      );
 
-        var userIds = userPriorities.Select(x => x.UserId).ToList();
-        var jobs = pm.UseTransaction(() => {
-          return jobDao.GetAll()
-            .Where(x => userIds.Contains(x.OwnerUserId))
-            .Select(x => new {
-              Id = x.JobId,
-              DateCreated = x.DateCreated,
-              OwnerUserId = x.OwnerUserId
-            })
-            .ToList();
-        });
+      var userIds = userPriorities.Select(x => x.UserId).ToList();
+      var jobs = pm.UseTransaction(() => {
+        return jobDao.GetAll()
+          .Where(x => userIds.Contains(x.OwnerUserId))
+          .Select(x => new {
+            Id = x.JobId,
+            DateCreated = x.DateCreated,
+            OwnerUserId = x.OwnerUserId
+          })
+          .ToList();
+      });
 
-        var taskJobRelations = tasks.Join(jobs,
-          task => task.JobId,
-          job => job.Id,
-          (task, job) => new { Task = task, JobInfo = job })
-          .OrderByDescending(x => x.Task.Priority)
-          .ToList();
+      var taskJobRelations = tasks.Join(jobs,
+        task => task.JobId,
+        job => job.Id,
+        (task, job) => new { Task = task, JobInfo = job })
+        .OrderByDescending(x => x.Task.Priority)
+        .ToList();
 
-        var scheduledTasks = new List<TaskInfoForScheduler>();
-        int priorityIndex = 0;
+      var scheduledTasks = new List<TaskInfoForScheduler>();
+      int priorityIndex = 0;
 
-        if (count == 0 || count > taskJobRelations.Count) count = taskJobRelations.Count;
+      if (count == 0 || count > taskJobRelations.Count) count = taskJobRelations.Count;
 
-        for (int i = 0; i < count; i++) {
-          var defaultEntry = taskJobRelations.First(); // search first task which is not included yet
-          var priorityEntries = taskJobRelations.Where(x => x.JobInfo.OwnerUserId == userPriorities[priorityIndex].UserId).ToArray(); // search for tasks with desired user priority
-          while (!priorityEntries.Any() && priorityIndex < userPriorities.Length - 1) {
+      for (int i = 0; i < count; i++) {
+        var defaultEntry = taskJobRelations.First(); // search first task which is not included yet
+        var priorityEntries = taskJobRelations.Where(x => x.JobInfo.OwnerUserId == userPriorities[priorityIndex].UserId).ToArray(); // search for tasks with desired user priority
+        while (!priorityEntries.Any() && priorityIndex < userPriorities.Length - 1) {
+          priorityIndex++;
+          priorityEntries = taskJobRelations.Where(x => x.JobInfo.OwnerUserId == userPriorities[priorityIndex].UserId).ToArray();
+        }
+        if (priorityEntries.Any()) { // tasks with desired user priority found
+          var priorityEntry = priorityEntries.OrderByDescending(x => x.Task.Priority).ThenBy(x => x.JobInfo.DateCreated).First();
+          if (defaultEntry.Task.Priority <= priorityEntry.Task.Priority) {
+            taskJobRelations.Remove(priorityEntry);
+            scheduledTasks.Add(priorityEntry.Task);
+            UpdateUserPriority(pm, userPriorities[priorityIndex]);
             priorityIndex++;
-            priorityEntries = taskJobRelations.Where(x => x.JobInfo.OwnerUserId == userPriorities[priorityIndex].UserId).ToArray();
-          }
-          if (priorityEntries.Any()) { // tasks with desired user priority found
-            var priorityEntry = priorityEntries.OrderByDescending(x => x.Task.Priority).ThenBy(x => x.JobInfo.DateCreated).First();
-            if (defaultEntry.Task.Priority <= priorityEntry.Task.Priority) {
-              taskJobRelations.Remove(priorityEntry);
-              scheduledTasks.Add(priorityEntry.Task);
-              UpdateUserPriority(pm, userPriorities[priorityIndex]);
-              priorityIndex++;
-            } else { // there are other tasks with higher priorities
-              taskJobRelations.Remove(defaultEntry);
-              scheduledTasks.Add(defaultEntry.Task);
-            }
-          } else {
+          } else { // there are other tasks with higher priorities
             taskJobRelations.Remove(defaultEntry);
             scheduledTasks.Add(defaultEntry.Task);
           }
-          if (priorityIndex >= (userPriorities.Length - 1)) priorityIndex = 0;
+        } else {
+          taskJobRelations.Remove(defaultEntry);
+          scheduledTasks.Add(defaultEntry.Task);
         }
-        return scheduledTasks;
+        if (priorityIndex >= (userPriorities.Length - 1)) priorityIndex = 0;
       }
+      return scheduledTasks;
+
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactClientInfoController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactClientInfoController.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactClientInfoController.cs	(revision 12858)
@@ -36,28 +36,26 @@
 
     public DT.FactClientInfo GetFactClientInfo(DateTime start, DateTime end) {
-      using (var pm = PersistenceManager) {
-        var factClientInfo = pm.FactClientInfoDao;
-        var query = factClientInfo.GetAll().Where(x => x.Time >= start && x.Time <= end);
-        return new DT.FactClientInfo {
-          Rows = query.Count(),
-          Clients = query.Select(x => x.ClientId).Distinct().Count()
-        };
-      }
+      var pm = PersistenceManager;
+      var factClientInfo = pm.FactClientInfoDao;
+      var query = factClientInfo.GetAll().Where(x => x.Time >= start && x.Time <= end);
+      return new DT.FactClientInfo {
+        Rows = query.Count(),
+        Clients = query.Select(x => x.ClientId).Distinct().Count()
+      };
     }
 
     public void Aggregate(DateTime start, DateTime end, int entries) {
-      using (var pm = PersistenceManager) {
-        var factClientInfoDao = pm.FactClientInfoDao;
-        var dimTimeDao = pm.DimTimeDao;
-        var clientIds = pm.UseTransaction(() => factClientInfoDao.GetAll()
-          .Where(x => x.Time >= start && x.Time <= end)
-          .Select(x => x.ClientId)
-          .Distinct()
-        );
-        foreach (var id in clientIds) {
-          AggregateClient(pm, id, start, end, entries);
-        }
-        dimTimeDao.DeleteUnusedTimes();
+      var pm = PersistenceManager;
+      var factClientInfoDao = pm.FactClientInfoDao;
+      var dimTimeDao = pm.DimTimeDao;
+      var clientIds = pm.UseTransaction(() => factClientInfoDao.GetAll()
+        .Where(x => x.Time >= start && x.Time <= end)
+        .Select(x => x.ClientId)
+        .Distinct()
+      );
+      foreach (var id in clientIds) {
+        AggregateClient(pm, id, start, end, entries);
       }
+      dimTimeDao.DeleteUnusedTimes();
     }
 
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactTaskController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactTaskController.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/FactTaskController.cs	(revision 12858)
@@ -35,47 +35,44 @@
 
     public DT.JobPage GetJobs(DateTime start, DateTime end, int page, int size) {
-      using (var pm = PersistenceManager) {
-        var dimJobDao = pm.DimJobDao;
-        var factTaskDao = pm.FactTaskDao;
-        return pm.UseTransaction(() => {
-          var query = dimJobDao.GetAll().Where(x => x.DateCreated >= start && x.DateCreated <= end);
-          return new DT.JobPage {
-            TotalJobs = query.Count(),
-            Jobs = query.OrderBy(x => x.DateCreated)
-              .Skip((page - 1) * size)
-              .Take(size)
-              .Select(x => new DT.Job {
-                Id = x.JobId,
-                Name = x.JobName,
-                Username = x.UserName,
-                DateCreated = x.DateCreated,
-                Tasks = x.TotalTasks,
-                Aggregated = !(factTaskDao.GetAll().Count(y => y.JobId == x.JobId) > 1)
-              })
-              .ToList()
-          };
-        });
-      }
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var factTaskDao = pm.FactTaskDao;
+      return pm.UseTransaction(() => {
+        var query = dimJobDao.GetAll().Where(x => x.DateCreated >= start && x.DateCreated <= end);
+        return new DT.JobPage {
+          TotalJobs = query.Count(),
+          Jobs = query.OrderBy(x => x.DateCreated)
+            .Skip((page - 1) * size)
+            .Take(size)
+            .Select(x => new DT.Job {
+              Id = x.JobId,
+              Name = x.JobName,
+              Username = x.UserName,
+              DateCreated = x.DateCreated,
+              Tasks = x.TotalTasks,
+              Aggregated = !(factTaskDao.GetAll().Count(y => y.JobId == x.JobId) > 1)
+            })
+            .ToList()
+        };
+      });
     }
 
     [HttpPost]
     public void AggregateJob(Guid id) {
-      using (var pm = PersistenceManager) {
-        AggregateJob(pm, id);
-      }
+      var pm = PersistenceManager;
+      AggregateJob(pm, id);
     }
 
     [HttpPost]
     public void AggregateAllJobs(DateTime start, DateTime end) {
-      using (var pm = PersistenceManager) {
-        var dimJobDao = pm.DimJobDao;
-        var jobIds = pm.UseTransaction(() => dimJobDao.GetAll()
-          .Where(x => x.DateCreated >= start && x.DateCreated <= end)
-          .Select(x => x.JobId)
-          .ToList()
-        );
-        foreach (var id in jobIds) {
-          AggregateJob(pm, id);
-        }
+      var pm = PersistenceManager;
+      var dimJobDao = pm.DimJobDao;
+      var jobIds = pm.UseTransaction(() => dimJobDao.GetAll()
+        .Where(x => x.DateCreated >= start && x.DateCreated <= end)
+        .Select(x => x.JobId)
+        .ToList()
+      );
+      foreach (var id in jobIds) {
+        AggregateJob(pm, id);
       }
     }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/PluginController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/PluginController.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/PluginController.cs	(revision 12858)
@@ -34,51 +34,48 @@
 
     public DT.PluginPage GetUnusedPlugins(int page, int size) {
-      using (var pm = PersistenceManager) {
-        var pluginDao = pm.PluginDao;
-        var requiredPluginDao = pm.RequiredPluginDao;
-        var taskDao = pm.TaskDao;
-        return pm.UseTransaction(() => {
-          var taskIds = taskDao.GetAll().Select(x => x.TaskId);
-          var usedPluginIds = requiredPluginDao.GetAll()
-            .Where(x => taskIds.Contains(x.TaskId))
-            .Select(x => x.PluginId)
-            .Distinct();
-          var query = pluginDao.GetAll().Where(x => !usedPluginIds.Any(y => y == x.PluginId));
-          return new DT.PluginPage {
-            TotalPlugins = query.Count(),
-            Plugins = query.OrderBy(x => x.DateCreated).ThenBy(x => x.Name)
-              .Skip((page - 1) * size)
-              .Take(size).Select(x => new DT.Plugin {
-                Id = x.PluginId,
-                Name = x.Name,
-                Version = x.Version,
-                DateCreated = x.DateCreated
-              })
-              .ToList()
-          };
-        });
-      }
+      var pm = PersistenceManager;
+      var pluginDao = pm.PluginDao;
+      var requiredPluginDao = pm.RequiredPluginDao;
+      var taskDao = pm.TaskDao;
+      return pm.UseTransaction(() => {
+        var taskIds = taskDao.GetAll().Select(x => x.TaskId);
+        var usedPluginIds = requiredPluginDao.GetAll()
+          .Where(x => taskIds.Contains(x.TaskId))
+          .Select(x => x.PluginId)
+          .Distinct();
+        var query = pluginDao.GetAll().Where(x => !usedPluginIds.Any(y => y == x.PluginId));
+        return new DT.PluginPage {
+          TotalPlugins = query.Count(),
+          Plugins = query.OrderBy(x => x.DateCreated).ThenBy(x => x.Name)
+            .Skip((page - 1) * size)
+            .Take(size).Select(x => new DT.Plugin {
+              Id = x.PluginId,
+              Name = x.Name,
+              Version = x.Version,
+              DateCreated = x.DateCreated
+            })
+            .ToList()
+        };
+      });
     }
 
     [HttpPost]
     public void DeletePlugin(Guid id) {
-      using (var pm = PersistenceManager) {
-        var pluginDao = pm.PluginDao;
-        pm.UseTransaction(() => {
-          pluginDao.Delete(id);
-          pm.SubmitChanges();
-        });
-      }
+      var pm = PersistenceManager;
+      var pluginDao = pm.PluginDao;
+      pm.UseTransaction(() => {
+        pluginDao.Delete(id);
+        pm.SubmitChanges();
+      });
     }
 
     [HttpPost]
     public void DeleteUnusedPlugins() {
-      using (var pm = PersistenceManager) {
-        var pluginDao = pm.PluginDao;
-        pm.UseTransaction(() => {
-          pluginDao.DeleteUnusedPlugins();
-          pm.SubmitChanges();
-        });
-      }
+      var pm = PersistenceManager;
+      var pluginDao = pm.PluginDao;
+      pm.UseTransaction(() => {
+        pluginDao.DeleteUnusedPlugins();
+        pm.SubmitChanges();
+      });
     }
   }
Index: branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs
===================================================================
--- branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 12857)
+++ branches/HiveStatistics/sources/HeuristicLab.Services.WebApp.Maintenance/3.3/WebApi/SpaceUsageController.cs	(revision 12858)
@@ -51,6 +51,6 @@
         "UserPriority"
       };
-      using (var pm = PersistenceManager) {
-        return pm.UseTransaction(() => (
+      var pm = PersistenceManager;
+      return pm.UseTransaction(() => (
           from table in tables
           select pm.GetTableInformation(table) into tableInformation
@@ -59,5 +59,4 @@
           ).ToList()
         );
-      }
     }
 
@@ -71,6 +70,6 @@
         "statistics.FactTask"
       };
-      using (var pm = PersistenceManager) {
-        return pm.UseTransaction(() => (
+      var pm = PersistenceManager;
+      return pm.UseTransaction(() => (
           from table in tables
           select pm.GetTableInformation(table) into tableInformation
@@ -79,5 +78,4 @@
           ).ToList()
         );
-      }
     }
 
